<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="id"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          :need-page="false"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <!--            <template v-if="column.key === 'thumb'">-->
            <!--              <a-avatar-->
            <!--                :src="`https://gxtyzx.gxsportscenter.com/uploads/images/${record.thumb}`"-->
            <!--                :width="50"-->
            <!--              />-->
            <!--            </template>-->
            <template v-if="column.key === 'price'">
              <span>￥{{ formatNumber(record.price) }}</span>
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a-button :disabled="true" @click="openEdit(record)"
                  >修改</a-button
                >
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a-button :disabled="true" class="ele-text-danger"
                    >删除</a-button
                  >
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <ThinkSiteEdit
        v-model:visible="showEdit"
        :data="current"
        @done="reload"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { formatNumber } from 'ele-admin-pro/es';
  import Search from './components/search.vue';
  import ThinkSiteEdit from './components/thinkSiteEdit.vue';
  import {
    pageThinkSite,
    removeThinkSite,
    removeBatchThinkSite,
    listThinkSite
  } from '@/api/think/thinkSite';
  import type { ThinkSite, ThinkSiteParam } from '@/api/think/thinkSite/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<ThinkSite[]>([]);
  // 当前编辑数据
  const current = ref<ThinkSite | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = () => {
    return listThinkSite();
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: 'ID',
      dataIndex: 'id',
      key: 'id',
      width: 90
    },
    {
      title: '场馆名称',
      dataIndex: 'name',
      key: 'name',
      align: 'center'
    },
    // {
    //   title: '场馆图片',
    //   dataIndex: 'thumb',
    //   key: 'thumb',
    //   align: 'center'
    // },
    {
      title: '每小时价格',
      dataIndex: 'price',
      key: 'price',
      align: 'center'
    },
    {
      title: '营业时间',
      dataIndex: 'businessTime',
      key: 'businessTime',
      align: 'center'
    },
    {
      title: '场馆位置',
      dataIndex: 'address',
      key: 'address',
      align: 'center'
    },
    {
      title: '场馆电话',
      dataIndex: 'tel',
      key: 'tel',
      align: 'center'
    },
    {
      title: '排序号',
      dataIndex: 'sort',
      key: 'sort',
      align: 'center'
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      key: 'createTime',
      align: 'center',
      ellipsis: true,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd HH:mm')
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: ThinkSiteParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: ThinkSite) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: ThinkSite) => {
    const hide = message.loading('请求中..', 0);
    removeThinkSite(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchThinkSite(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: ThinkSite) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'ThinkSite'
  };
</script>

<style lang="less" scoped></style>
